/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2007 hiyohiyo, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "CrystalCpuid.h"
#include "CrystalCpuidDlg.h"

#include "GetFileVersion.h"

#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CCrystalCpuidApp

BEGIN_MESSAGE_MAP(CCrystalCpuidApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()

static BOOL IsFileExistEx(const TCHAR* path, const TCHAR* fileName);

// CCrystalCpuidApp construction

CCrystalCpuidApp::CCrystalCpuidApp()
{
}

CCrystalCpuidApp::~CCrystalCpuidApp()
{
	if(m_WmiInfo != NULL)
	{
		delete m_WmiInfo;
		m_WmiInfo = NULL;
	}
}


// The one and only CCrystalCpuidApp object

CCrystalCpuidApp theApp;


// CCrystalCpuidApp initialization

BOOL CCrystalCpuidApp::InitInstance()
{
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	m_WmiInfo = NULL;

	CWinApp::InitInstance();
	CString DefaultTheme;
	CString DefaultLanguage;
	TCHAR tmp[MAX_PATH];
	TCHAR *ptrEnd;

	GetModuleFileName(NULL, tmp, MAX_PATH);
	if((ptrEnd = _tcsrchr(tmp, '\\')) != NULL){*ptrEnd = '\0';}

	m_ThemeDir.Format(_T("%s\\%s"), tmp, THEME_DIR);
	m_LangDir.Format(_T("%s\\%s"), tmp, LANGUAGE_DIR);

	DefaultTheme.Format(_T("%s\\%s"), tmp, DEFAULT_THEME);
	DefaultLanguage.Format(_T("%s\\%s"), tmp, DEFAULT_LANGUAGE);

	m_MainDlgPath.Format(_T("%s\\") DIALOG_DIR MAIN_DIALOG, tmp);
	m_AboutDlgPath.Format(_T("%s\\") DIALOG_DIR ABOUT_DIALOG, tmp);
	m_FeatureFlagsDlgPath.Format(_T("%s\\")DIALOG_DIR FEATURE_FLAGS_DIALOG, tmp);
	m_BiosInfoDlgPath.Format(_T("%s\\")DIALOG_DIR BIOS_INFO_DIALOG, tmp);
	m_CpuidInfoDlgPath.Format(_T("%s\\")DIALOG_DIR CPUID_INFO_DIALOG, tmp);

	if(! IsFileExistEx(m_MainDlgPath, MAIN_DIALOG))					{	return FALSE;	}
	if(! IsFileExistEx(m_AboutDlgPath, ABOUT_DIALOG))				{	return FALSE;	}
	if(! IsFileExistEx(m_FeatureFlagsDlgPath, FEATURE_FLAGS_DIALOG)){	return FALSE;	}
	if(! IsFileExistEx(m_BiosInfoDlgPath, BIOS_INFO_DIALOG))		{	return FALSE;	}
	if(! IsFileExistEx(m_CpuidInfoDlgPath, CPUID_INFO_DIALOG))		{	return FALSE;	}
//	if(! IsFileExistEx(m_Path, _DIALOG))							{	return FALSE;	}

	if(! IsFileExistEx(DefaultTheme, DEFAULT_THEME))				{	return FALSE;	}
	if(! IsFileExistEx(DefaultLanguage, DEFAULT_LANGUAGE))			{	return FALSE;	}

	// Multimedia Timer Setting
	TIMECAPS tc;
	timeGetDevCaps(&tc,sizeof(TIMECAPS));
	timeBeginPeriod(tc.wPeriodMin);

	// IE Version Check.
	int IE = GetFileVersion(_T("Shdocvw.dll"));
	if(IE >= 400){
		CCrystalCpuidDlg dlg;
		m_pMainWnd = &dlg;
		INT_PTR nResponse = dlg.DoModal();
	}else{
		AfxMessageBox(_T("CrystalCPUID is required IE6 or later."));
	}

	timeEndPeriod(tc.wPeriodMin);

	return FALSE;
}

CWmiInfo* CCrystalCpuidApp::GetWmiInfo()
{
	if(m_WmiInfo == NULL)
	{
		m_WmiInfo = new CWmiInfo;
	}

	return m_WmiInfo;
}

BOOL IsFileExistEx(const TCHAR* path, const TCHAR* fileName)
{
	if(! IsFileExist(path))
	{
		CString cstr;
		cstr.Format(_T("Not Found \"%s\"."), fileName); 
		AfxMessageBox(cstr);
		return FALSE;
	}
	return TRUE;
}
