/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2007 hiyohiyo, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "CrystalCpuid.h"
#include "CrystalCpuidDlg.h"

#include "GetFileVersion.h"

#include <exdispid.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define SIZE_X		480
#define SIZE_Y		360

// CCrystalCpuidDlg dialog

BEGIN_DHTML_EVENT_MAP(CCrystalCpuidDlg)
END_DHTML_EVENT_MAP()

CCrystalCpuidDlg::CCrystalCpuidDlg(CWnd* pParent /*=NULL*/)
	: CDHtmlDialogEx(CCrystalCpuidDlg::IDD, NULL /*CCrystalCpuidDlg::IDH*/, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCrystalCpuidDlg::DoDataExchange(CDataExchange* pDX)
{
	CDHtmlDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CCrystalCpuidDlg, CDHtmlDialogEx)
	//}}AFX_MSG_MAP
	ON_WM_WINDOWPOSCHANGING()
	ON_COMMAND(ID_HELP_ABOUT, &CCrystalCpuidDlg::OnAbout)
	ON_COMMAND(ID_FEATURE_FLAGS, &CCrystalCpuidDlg::OnFeatureFlags)
	ON_COMMAND(ID_BIOS_INFO, &CCrystalCpuidDlg::OnBiosInfo)
	ON_COMMAND(ID_CPUID_INFO, &CCrystalCpuidDlg::OnCpuidInfo)
END_MESSAGE_MAP()

// CCrystalCpuidDlg message handlers

BOOL CCrystalCpuidDlg::OnInitDialog()
{
	CDHtmlDialogEx::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	InitThemeLang();
	InitMenu();

	InitDHtmlDialog(SIZE_X, SIZE_Y + GetSystemMetrics(SM_CYMENU), 
		((CCrystalCpuidApp*)AfxGetApp())->m_MainDlgPath);

	return TRUE;
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCrystalCpuidDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDHtmlDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCrystalCpuidDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CCrystalCpuidDlg::OnDocumentComplete(LPDISPATCH pDisp, LPCTSTR szUrl)
{
	CString cstr;
	cstr = szUrl;
	if(cstr.Find(_T("html")) != -1 || cstr.Find(_T("dlg")) != -1)
	{
		m_FlagShowWindow = TRUE;
		ShowWindow(SW_SHOW);
		ChangeTheme(m_CurrentTheme);
		ChangeLang(m_CurrentLang);
	}
}

void CCrystalCpuidDlg::OnAbout()
{
	m_AboutDlg = new CAboutDlg(this);
	m_AboutDlg->Create(CAboutDlg::IDD, m_AboutDlg, ID_HELP_ABOUT, this);
}

void CCrystalCpuidDlg::OnFeatureFlags()
{
	m_FeatureFlagsDlg = new CFeatureFlagsDlg(this);
	m_FeatureFlagsDlg->Create(CFeatureFlagsDlg::IDD, m_FeatureFlagsDlg, ID_FEATURE_FLAGS, this);
}

void CCrystalCpuidDlg::OnBiosInfo()
{
	m_BiosInfoDlg = new CBiosInfoDlg(this);
	m_BiosInfoDlg->Create(CBiosInfoDlg::IDD, m_BiosInfoDlg, ID_BIOS_INFO, this);
}

void CCrystalCpuidDlg::OnCpuidInfo()
{
	m_CpuidInfoDlg = new CCpuidInfoDlg(this);
	m_CpuidInfoDlg->Create(CCpuidInfoDlg::IDD, m_CpuidInfoDlg, ID_CPUID_INFO, this);
}

